/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <libc.h>
#include <string.h>
#include <stdio.h>

#include "OO7.hxx"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"

//////////////////////////////////////////////////////////////////
//
// Query #1 - randomly choose "Query1RepeatCnt" atomic parts by 
// lookup on their id field.  An index can be used for the
// actual lookup.  
//
/////////////////////////////////////////////////////////////////

extern int	debugMode;

//////////////////////////////////////////////////////////////////
//
// Routine to do Query #1
//
//////////////////////////////////////////////////////////////////


int query1()
{
    // set random seed so "hot" runs are truly hot
    srandom(1);

    // randomly select parts and process them

    int partId;
    AtomicPart* atom;

    for (int i = 0; i < Query1RepeatCnt; i++) {

	// generate part id and lookup part

	partId = (int) (random() % TotalAtomicParts) + 1;
        atom = AtomicPart::extent_id->getFirst(partId) ;

        if (debugMode) {
            printf("    In Query1, partId = %d:\n", partId);
        }

	// process part by invoking DoNothing method

        atom->DoNothing();
    }

    return Query1RepeatCnt;
}

